"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from formance_sdk_python.models.shared import (
    posttransaction as shared_posttransaction,
    transactionsresponse as shared_transactionsresponse,
)
from formance_sdk_python.types import BaseModel
from formance_sdk_python.utils import (
    FieldMetadata,
    PathParamMetadata,
    QueryParamMetadata,
    RequestMetadata,
)
import httpx
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class CreateTransactionRequestTypedDict(TypedDict):
    post_transaction: shared_posttransaction.PostTransactionTypedDict
    r"""The request body must contain at least one of the following objects:
    - `postings`: suitable for simple transactions
    - `script`: enabling more complex transactions with Numscript

    """
    ledger: str
    r"""Name of the ledger."""
    preview: NotRequired[bool]
    r"""Set the preview mode. Preview mode doesn't add the logs to the database or publish a message to the message broker."""


class CreateTransactionRequest(BaseModel):
    post_transaction: Annotated[
        shared_posttransaction.PostTransaction,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]
    r"""The request body must contain at least one of the following objects:
    - `postings`: suitable for simple transactions
    - `script`: enabling more complex transactions with Numscript

    """

    ledger: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Name of the ledger."""

    preview: Annotated[
        Optional[bool],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Set the preview mode. Preview mode doesn't add the logs to the database or publish a message to the message broker."""


class CreateTransactionResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    transactions_response: NotRequired[
        shared_transactionsresponse.TransactionsResponseTypedDict
    ]
    r"""OK"""


class CreateTransactionResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    transactions_response: Optional[
        shared_transactionsresponse.TransactionsResponse
    ] = None
    r"""OK"""
