"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from formance_sdk_python.models.shared import (
    transactionresponse as shared_transactionresponse,
)
from formance_sdk_python.types import BaseModel
from formance_sdk_python.utils import (
    FieldMetadata,
    PathParamMetadata,
    QueryParamMetadata,
    validate_int,
)
import httpx
import pydantic
from pydantic.functional_validators import BeforeValidator
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class RevertTransactionRequestTypedDict(TypedDict):
    ledger: str
    r"""Name of the ledger."""
    txid: int
    r"""Transaction ID."""
    disable_checks: NotRequired[bool]
    r"""Allow to disable balances checks"""


class RevertTransactionRequest(BaseModel):
    ledger: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Name of the ledger."""

    txid: Annotated[
        Annotated[int, BeforeValidator(validate_int)],
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Transaction ID."""

    disable_checks: Annotated[
        Optional[bool],
        pydantic.Field(alias="disableChecks"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Allow to disable balances checks"""


class RevertTransactionResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    transaction_response: NotRequired[
        shared_transactionresponse.TransactionResponseTypedDict
    ]
    r"""OK"""


class RevertTransactionResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    transaction_response: Optional[shared_transactionresponse.TransactionResponse] = (
        None
    )
    r"""OK"""
