"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .v2monetary import V2Monetary, V2MonetaryTypedDict
from .v2subject import V2Subject, V2SubjectTypedDict
from datetime import datetime
from formance_sdk_python.types import BaseModel
from typing import Dict, List, Optional
from typing_extensions import NotRequired, TypedDict


class V2DebitWalletRequestTypedDict(TypedDict):
    amount: V2MonetaryTypedDict
    metadata: Dict[str, str]
    r"""Metadata associated with the wallet."""
    balances: NotRequired[List[str]]
    description: NotRequired[str]
    destination: NotRequired[V2SubjectTypedDict]
    pending: NotRequired[bool]
    r"""Set to true to create a pending hold. If false, the wallet will be debited immediately."""
    timestamp: NotRequired[datetime]
    r"""cannot be used in conjunction with `pending` property"""


class V2DebitWalletRequest(BaseModel):
    amount: V2Monetary

    metadata: Dict[str, str]
    r"""Metadata associated with the wallet."""

    balances: Optional[List[str]] = None

    description: Optional[str] = None

    destination: Optional[V2Subject] = None

    pending: Optional[bool] = None
    r"""Set to true to create a pending hold. If false, the wallet will be debited immediately."""

    timestamp: Optional[datetime] = None
    r"""cannot be used in conjunction with `pending` property"""
